<script setup lang="ts">
import { provide, ref } from 'vue';
import { useProductStore } from '@/stores/product'
import { type Product } from '@/types/Product'
import { useReceiptStore } from '@/stores/receipt'

import ProductList from '@/components/ProductList.vue';
import DrinkList from '@/components/DrinkList.vue';
import ReceiptDetailTable from './ReceiptDetailTable.vue';
import MemberCard from './MemberCard.vue';
import ReceiptCard from '@/views/POS/ReceiptCard.vue';
import ReceiptDialog from './ReceiptDialog.vue';
const promotion = ref({selected: false})
const ProductStore = useProductStore();
const ReceiptStore = useReceiptStore();
const products1 = ProductStore.Sortlist('drink')
const products2 = ProductStore.Sortlist('bakery')
const products3 = ProductStore.Sortlist('foods')
const tab = ref(1);
let drinkTabBGC = ref('rgb(231, 191, 80)')
let drinkTabC = ref('white')
let bakeryTabBGC = ref('')
let bakeryTabC = ref('')
let foodTabBGC = ref('')
let foodTabC = ref('')
function BGC(num: number) {
    resetColor()
    if (num == 1) {
        drinkTabBGC.value = 'rgb(231, 191, 80)'
        drinkTabC.value = 'white'
    }
    else if (num == 2) {
        bakeryTabBGC.value = 'rgb(231, 191, 80)'
        bakeryTabC.value = 'white'
    }
    else if (num == 3) {
        foodTabBGC.value = 'rgb(231, 191, 80)'
        foodTabC.value = 'white'
    }

}

function resetColor() {
    drinkTabBGC.value = ''
    drinkTabC.value = ''
    bakeryTabBGC.value = ''
    bakeryTabC.value = ''
    foodTabBGC.value = ''
    foodTabC.value = ''
}

const selectTab = (tabNumber: number) => {
    tab.value = tabNumber;
}
const divReceiptItem = ref<HTMLElement | null>(null)
const selected = (p: Product) => {
    console.log('ProductView: ', + p);
    ReceiptStore.addReceiptItem(p)
    if (divReceiptItem.value) {
        divReceiptItem.value.scrollTo(0, divReceiptItem.value.scrollHeight)
    }
};

const dialog = ref(false)
provide('receiptDialog', dialog)

const showReceipt = function () {
    ReceiptStore.showReceiptDialog()
} 
</script>

<template>
    <v-container>
        <v-row>
            <v-col cols="12" md="7" style="background-color: whitesmoke;">
                <v-container>
                    <v-row align="center" justify="center">
                        <v-col cols="4" md="4">
                            <v-btn @click="selectTab(1), BGC(1)" elevation="4" size="large" prepend-icon="mdi-coffee" block
                                rounded="xl" :style="{ backgroundColor: drinkTabBGC, color: drinkTabC }">Drinks</v-btn>
                        </v-col>

                        <v-col cols="4" md="4">
                            <v-btn @click="selectTab(2), BGC(2)" elevation="4" size="large" prepend-icon="mdi-cupcake" block
                                rounded="xl" :style="{ backgroundColor: bakeryTabBGC, color: bakeryTabC }">Bakery</v-btn>
                        </v-col>

                        <v-col cols="4" md="4">
                            <v-btn @click="selectTab(3), BGC(3)" elevation="4" size="large"
                                prepend-icon="mdi-silverware-fork-knife" block rounded="xl"
                                :style="{ backgroundColor: foodTabBGC, color: foodTabC }">Food</v-btn>
                        </v-col>
                    </v-row>
                </v-container>
                <v-sheet min-width="300" max-width="900">
                    <v-window v-model="tab">
                        <v-window-item :value="1">
                            <div
                                style="padding-left: 15px;padding-top: 0px;padding-bottom: 0px;font-size: 25px; background-color: whitesmoke; font-weight: bold;">
                                Drink</div>
                            <DrinkList :products="products1" @selected-product="selected">

                            </DrinkList>
                        </v-window-item>

                        <v-window-item :value="2">
                            <div
                                style="padding-left: 15px;padding-top: 0px;padding-bottom: 0px;font-size: 25px; background-color: whitesmoke; font-weight: bold;">
                                Bakery</div>
                            <ProductList :products="products2" @selected-product="selected">

                            </ProductList>
                        </v-window-item>

                        <v-window-item :value="3">
                            <div
                                style="padding-left: 15px;padding-top: 0px;padding-bottom: 0px;font-size: 25px; background-color: whitesmoke; font-weight: bold;">
                                Food</div>
                            <ProductList :products="products3" @selected-product="selected">

                            </ProductList>
                        </v-window-item>
                    </v-window>
                </v-sheet>
            </v-col>

            <v-col cols="12" md="5" style="background-color: whitesmoke;">

                <v-container style="padding: 5px;background-color: whitesmoke;">
                    <v-sheet style="padding: 5px;background-color: white;padding-right: 10px;" rounded>
                        <v-row>
                            <v-col cols="12" class="pl-5 pb-1">
                                <div style="font-size: 20px; font-weight: bolder; padding-left: 10px">
                                    <h3>Order</h3>
                                </div>
                                <div ref="divReceiptItem" style="height:300;overflow: auto;">
                                    <v-sheet min-width="300" max-width="900" height="250" elevation="6" rounded>
                                        <ReceiptDetailTable></ReceiptDetailTable>
                                    </v-sheet>
                                </div>

                            </v-col>
                            <v-col cols="12" class="pt-0 pb-1 pl-8 pr-8">
                                <v-sheet min-width="300" max-width="900" height="173" rounded
                                    style="padding: 0px; background-color: rgb(247, 247, 247);">

                                    <MemberCard></MemberCard>

                                </v-sheet>
                            </v-col>
                            <v-col cols="12" class="pt-0 mt-0 pl-8 pr-8">
                                <v-sheet min-width="300" max-width="900" height="185" rounded class="pt-0"
                                    style=" background-color: rgb(247, 247, 247);">
                                    <ReceiptCard></ReceiptCard>
                                </v-sheet>
                            </v-col>
                            <v-col cols="6" class="pt-0 pl-5 text-center">
                                <v-btn density="compact" size="x-large" width="200px" height="30px"
                                    style="font-weight: bold; background-color: rgb(0, 149, 255); color: white;"
                                    @click="showReceipt">Confirm</v-btn>

                            </v-col>
                            <v-col cols="6" class="pt-0 pl-5 text-center">
                                <v-btn density="compact" size="x-large" width="200px" height="30px"
                                    style="font-weight: bold; background-color: red; color: white;"
                                    @click="ReceiptStore.clear()" >
                                    Cancel
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-sheet>

                </v-container>
            </v-col>
        </v-row>
    </v-container>
    <ReceiptDialog />
</template>
